/**
 *
 * @type {mtango.ui.DeviceAttributeUI}
 */
mtango.ui.Image = mtango.ui.DeviceAttributeUI.extend("DeviceAttributeImage",
    /* @Static*/
    {
        kViewUrl: 'engines/mTangoUI/views/fld_img.ejs',
        attributes:{
            width:'int',
            height:'int'
        },
        /**
         *
         * @param {jQuery} $el
         * @returns {Object}
         * @private
         */
        _parse:function($el){
            console.debug("An image attribute has been found on the page. Parsing ...");
            var result = this._super($el);

            result.width = parseInt($el.attr('width'));
            result.height = parseInt($el.attr('height'));

            result.view_url = this.kViewUrl;

            return result;
        }
    },
    /* @Prototype*/
    {
        /**
         * This function does nothing
         */
        write:function(){
            console.warn("mtango.Image.write is not supported!")
        },
        _callback:function(){
            return MVC.Function.bind(function(response){
                if(response.valid() && this.$element.has('img').length > 0)
                    $('img',this.$element).attr({
                        src:response.argout,
                        width:this.width,
                        height:this.height
                    });
                else {
                    this.wrapped.response = response;
                    this.update();
                }
            },this);
        }
    }
);

if(typeof Image == 'undefined') Image = mtango.ui.Image;