(function(){
    importClass(Packages.fr.esrf.TangoApi.DeviceProxy);
    importClass(Packages.fr.esrf.TangoDs.TangoConst);
})();

create_tango_proxy = function(url){
    //TODO check url
    var deviceProxy = new DeviceProxy(url);

    var result = {
        name:deviceProxy.get_name(),
        class_name:deviceProxy.get_class(),
        attributes:[],
        commands:[]
    };

    var infos = deviceProxy.get_attribute_info_ex();
    var info = null;
    for (var i = 0, size = infos.length ; i < size ;++i) {
        info = infos[i];
        result.attributes.push({
            name: info.name,
            label: info.label,
            description: info.description.replaceAll("(\\r|\\n)", ""),
            read_only: info.writable.value() == 0,
            data_format: info.data_format,
            data_type: TangoConst.Tango_CmdArgTypeName[info.data_type],
            unit: info.unit,
            display_unit: info.display_unit,
            max_x: info.max_dim_x,
            max_y: info.max_dim_y,
            max_value: info.max_value,
            min_value: info.min_value
        });
    }

    infos = deviceProxy.command_list_query();
    for (var i = 0, size = infos.length ; i < size ;++i) {
        info = infos[i];
        result.commands.push({
            name: info.cmd_name,
            input_type: TangoConst.Tango_CmdArgTypeName[info.in_type],
            input_desc: info.in_type_desc,
            output_type: TangoConst.Tango_CmdArgTypeName[info.out_type],
            output_desc: info.out_type_desc
        });
    }

    return result;
};